/*
  start of a generic gui Device
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __GUIDEVICE_H
#define __GUIDEVICE_H


#include <deviceWidgets/guiDeviceCore.h>

#include <widgetUtil/menuDescription.h>
#include <kpopmenu.h>


/**
  This add decoration stuff to the core gui device.<p>
  - popupmenus<p>
  - configuration options<p>
  - icons etc.....<p>


*/



class GuiDevice : public GuiDeviceCore  {
  Q_OBJECT


 public:
  GuiDevice( QWidget *parent=0, const char *name=0 );
  ~GuiDevice();

  void insertMenu(char* text,QObject* receiver,const char* signal);
  void setDevice(OutputDevice* device);
  
  
 public slots:
  void selected();  

 protected:
  void mousePressEvent ( QMouseEvent* mouseEvent);

 private:
  KPopupMenu* createPopupMenu();
  MenuDescription* menuDescription;

};


#endif



    
